/* Utils.c generated by valac 0.56.17, the Vala compiler
 * generated from Utils.vala, do not modify */

/* Copyright 2018 elementary, Inc. (https://elementary.io)
*
* This program is free software: you can redistribute it
* and/or modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation, either version 3 of the
* License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program. If not, see http://www.gnu.org/licenses/.
*/

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <packagekit-glib2/packagekit.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_rand_free0(var) ((var == NULL) ? NULL : (var = (g_rand_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

VALA_EXTERN void utils_shuffle_array (GType t_type,
                          GBoxedCopyFunc t_dup_func,
                          GDestroyNotify t_destroy_func,
                          gpointer* array,
                          gint array_length1);
VALA_EXTERN void utils_swap (GType t_type,
                 GBoxedCopyFunc t_dup_func,
                 GDestroyNotify t_destroy_func,
                 gconstpointer* x,
                 gconstpointer* y);
VALA_EXTERN guint utils_get_file_age (GFile* file);
VALA_EXTERN const gchar* utils_pk_status_to_string (PkStatusEnum status);
VALA_EXTERN gchar* utils_unescape_markup (const gchar* escaped_text);
VALA_EXTERN gboolean utils_is_running_in_demo_mode (void);

void
utils_shuffle_array (GType t_type,
                     GBoxedCopyFunc t_dup_func,
                     GDestroyNotify t_destroy_func,
                     gpointer* array,
                     gint array_length1)
{
	GRand* rand = NULL;
	GRand* _tmp0_;
#line 20 "../src/Utils.vala"
	_tmp0_ = g_rand_new ();
#line 20 "../src/Utils.vala"
	rand = _tmp0_;
#line 82 "Utils.c"
	{
		gint i = 0;
#line 21 "../src/Utils.vala"
		i = 0;
#line 87 "Utils.c"
		{
			gboolean _tmp1_ = FALSE;
#line 21 "../src/Utils.vala"
			_tmp1_ = TRUE;
#line 21 "../src/Utils.vala"
			while (TRUE) {
#line 94 "Utils.c"
				GRand* _tmp3_;
#line 21 "../src/Utils.vala"
				if (!_tmp1_) {
#line 98 "Utils.c"
					gint _tmp2_;
#line 21 "../src/Utils.vala"
					_tmp2_ = i;
#line 21 "../src/Utils.vala"
					i = _tmp2_ + 1;
#line 104 "Utils.c"
				}
#line 21 "../src/Utils.vala"
				_tmp1_ = FALSE;
#line 21 "../src/Utils.vala"
				if (!(i < (array_length1 * 3))) {
#line 21 "../src/Utils.vala"
					break;
#line 112 "Utils.c"
				}
#line 22 "../src/Utils.vala"
				_tmp3_ = rand;
#line 22 "../src/Utils.vala"
				utils_swap (G_TYPE_POINTER, NULL, NULL, &array[0], &array[g_rand_int_range (_tmp3_, (gint32) 1, (gint32) array_length1)]);
#line 118 "Utils.c"
			}
		}
	}
#line 18 "../src/Utils.vala"
	_g_rand_free0 (rand);
#line 124 "Utils.c"
}

void
utils_swap (GType t_type,
            GBoxedCopyFunc t_dup_func,
            GDestroyNotify t_destroy_func,
            gconstpointer* x,
            gconstpointer* y)
{
	gpointer tmp = NULL;
	gpointer _tmp0_;
#line 27 "../src/Utils.vala"
	_tmp0_ = (((*x) != NULL) && (t_dup_func != NULL)) ? t_dup_func ((gpointer) (*x)) : ((gpointer) (*x));
#line 27 "../src/Utils.vala"
	tmp = _tmp0_;
#line 28 "../src/Utils.vala"
	*x = *y;
#line 29 "../src/Utils.vala"
	*y = tmp;
#line 26 "../src/Utils.vala"
	((tmp == NULL) || (t_destroy_func == NULL)) ? NULL : (tmp = (t_destroy_func (tmp), NULL));
#line 146 "Utils.c"
}

guint
utils_get_file_age (GFile* file)
{
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	guint64 mtime = 0ULL;
	GFileInfo* _tmp7_;
	guint64 now = 0ULL;
	time_t _tmp8_;
	GError* _inner_error0_ = NULL;
	guint result;
#line 32 "../src/Utils.vala"
	g_return_val_if_fail (file != NULL, 0U);
#line 162 "Utils.c"
	{
		GFileInfo* _tmp0_ = NULL;
		GFileInfo* _tmp1_;
		GFileInfo* _tmp2_;
#line 35 "../src/Utils.vala"
		_tmp1_ = g_file_query_info (file, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 35 "../src/Utils.vala"
		_tmp0_ = _tmp1_;
#line 35 "../src/Utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 173 "Utils.c"
			goto __catch0_g_error;
		}
#line 35 "../src/Utils.vala"
		_tmp2_ = _tmp0_;
#line 35 "../src/Utils.vala"
		_tmp0_ = NULL;
#line 35 "../src/Utils.vala"
		_g_object_unref0 (info);
#line 35 "../src/Utils.vala"
		info = _tmp2_;
#line 34 "../src/Utils.vala"
		_g_object_unref0 (_tmp0_);
#line 186 "Utils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 34 "../src/Utils.vala"
		e = _inner_error0_;
#line 34 "../src/Utils.vala"
		_inner_error0_ = NULL;
#line 37 "../src/Utils.vala"
		_tmp3_ = e;
#line 37 "../src/Utils.vala"
		_tmp4_ = _tmp3_->message;
#line 37 "../src/Utils.vala"
		g_warning ("Utils.vala:37: Error while getting file age: %s", _tmp4_);
#line 38 "../src/Utils.vala"
		result = G_MAXUINT;
#line 38 "../src/Utils.vala"
		_g_error_free0 (e);
#line 38 "../src/Utils.vala"
		_g_object_unref0 (info);
#line 38 "../src/Utils.vala"
		return result;
#line 212 "Utils.c"
	}
	__finally0:
#line 34 "../src/Utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 217 "Utils.c"
		guint _tmp5_ = 0U;
#line 34 "../src/Utils.vala"
		_g_object_unref0 (info);
#line 34 "../src/Utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 34 "../src/Utils.vala"
		g_clear_error (&_inner_error0_);
#line 34 "../src/Utils.vala"
		return _tmp5_;
#line 227 "Utils.c"
	}
#line 41 "../src/Utils.vala"
	_tmp6_ = info;
#line 41 "../src/Utils.vala"
	if (_tmp6_ == NULL) {
#line 42 "../src/Utils.vala"
		result = G_MAXUINT;
#line 42 "../src/Utils.vala"
		_g_object_unref0 (info);
#line 42 "../src/Utils.vala"
		return result;
#line 239 "Utils.c"
	}
#line 45 "../src/Utils.vala"
	_tmp7_ = info;
#line 45 "../src/Utils.vala"
	mtime = g_file_info_get_attribute_uint64 (_tmp7_, G_FILE_ATTRIBUTE_TIME_MODIFIED);
#line 46 "../src/Utils.vala"
	_tmp8_ = time (NULL);
#line 46 "../src/Utils.vala"
	now = (guint64) _tmp8_;
#line 48 "../src/Utils.vala"
	if (mtime > now) {
#line 49 "../src/Utils.vala"
		result = G_MAXUINT;
#line 49 "../src/Utils.vala"
		_g_object_unref0 (info);
#line 49 "../src/Utils.vala"
		return result;
#line 257 "Utils.c"
	}
#line 52 "../src/Utils.vala"
	if ((now - mtime) > ((guint64) G_MAXUINT)) {
#line 53 "../src/Utils.vala"
		result = G_MAXUINT;
#line 53 "../src/Utils.vala"
		_g_object_unref0 (info);
#line 53 "../src/Utils.vala"
		return result;
#line 267 "Utils.c"
	}
#line 56 "../src/Utils.vala"
	result = (guint) (now - mtime);
#line 56 "../src/Utils.vala"
	_g_object_unref0 (info);
#line 56 "../src/Utils.vala"
	return result;
#line 275 "Utils.c"
}

const gchar*
utils_pk_status_to_string (PkStatusEnum status)
{
	const gchar* result;
#line 61 "../src/Utils.vala"
	switch (status) {
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_SETUP:
#line 286 "Utils.c"
		{
#line 63 "../src/Utils.vala"
			result = _ ("Starting");
#line 63 "../src/Utils.vala"
			return result;
#line 292 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_WAIT:
#line 296 "Utils.c"
		{
#line 65 "../src/Utils.vala"
			result = _ ("Waiting");
#line 65 "../src/Utils.vala"
			return result;
#line 302 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_RUNNING:
#line 306 "Utils.c"
		{
#line 67 "../src/Utils.vala"
			result = _ ("Running");
#line 67 "../src/Utils.vala"
			return result;
#line 312 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_QUERY:
#line 316 "Utils.c"
		{
#line 69 "../src/Utils.vala"
			result = _ ("Querying");
#line 69 "../src/Utils.vala"
			return result;
#line 322 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_INFO:
#line 326 "Utils.c"
		{
#line 71 "../src/Utils.vala"
			result = _ ("Getting information");
#line 71 "../src/Utils.vala"
			return result;
#line 332 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_REMOVE:
#line 336 "Utils.c"
		{
#line 73 "../src/Utils.vala"
			result = _ ("Removing packages");
#line 73 "../src/Utils.vala"
			return result;
#line 342 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_DOWNLOAD:
#line 346 "Utils.c"
		{
#line 75 "../src/Utils.vala"
			result = _ ("Downloading");
#line 75 "../src/Utils.vala"
			return result;
#line 352 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_INSTALL:
#line 356 "Utils.c"
		{
#line 77 "../src/Utils.vala"
			result = _ ("Installing");
#line 77 "../src/Utils.vala"
			return result;
#line 362 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_REFRESH_CACHE:
#line 366 "Utils.c"
		{
#line 79 "../src/Utils.vala"
			result = _ ("Refreshing software list");
#line 79 "../src/Utils.vala"
			return result;
#line 372 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_UPDATE:
#line 376 "Utils.c"
		{
#line 81 "../src/Utils.vala"
			result = _ ("Installing updates");
#line 81 "../src/Utils.vala"
			return result;
#line 382 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_CLEANUP:
#line 386 "Utils.c"
		{
#line 83 "../src/Utils.vala"
			result = _ ("Cleaning up packages");
#line 83 "../src/Utils.vala"
			return result;
#line 392 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_OBSOLETE:
#line 396 "Utils.c"
		{
#line 85 "../src/Utils.vala"
			result = _ ("Obsoleting packages");
#line 85 "../src/Utils.vala"
			return result;
#line 402 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_DEP_RESOLVE:
#line 406 "Utils.c"
		{
#line 87 "../src/Utils.vala"
			result = _ ("Resolving dependencies");
#line 87 "../src/Utils.vala"
			return result;
#line 412 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_SIG_CHECK:
#line 416 "Utils.c"
		{
#line 89 "../src/Utils.vala"
			result = _ ("Checking signatures");
#line 89 "../src/Utils.vala"
			return result;
#line 422 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_TEST_COMMIT:
#line 426 "Utils.c"
		{
#line 91 "../src/Utils.vala"
			result = _ ("Testing changes");
#line 91 "../src/Utils.vala"
			return result;
#line 432 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_COMMIT:
#line 436 "Utils.c"
		{
#line 93 "../src/Utils.vala"
			result = _ ("Committing changes");
#line 93 "../src/Utils.vala"
			return result;
#line 442 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_REQUEST:
#line 446 "Utils.c"
		{
#line 95 "../src/Utils.vala"
			result = _ ("Requesting data");
#line 95 "../src/Utils.vala"
			return result;
#line 452 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_FINISHED:
#line 456 "Utils.c"
		{
#line 97 "../src/Utils.vala"
			result = _ ("Finished");
#line 97 "../src/Utils.vala"
			return result;
#line 462 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_CANCEL:
#line 466 "Utils.c"
		{
#line 99 "../src/Utils.vala"
			result = _ ("Cancelling");
#line 99 "../src/Utils.vala"
			return result;
#line 472 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_DOWNLOAD_REPOSITORY:
#line 476 "Utils.c"
		{
#line 101 "../src/Utils.vala"
			result = _ ("Downloading repository information");
#line 101 "../src/Utils.vala"
			return result;
#line 482 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_DOWNLOAD_PACKAGELIST:
#line 486 "Utils.c"
		{
#line 103 "../src/Utils.vala"
			result = _ ("Downloading list of packages");
#line 103 "../src/Utils.vala"
			return result;
#line 492 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_DOWNLOAD_FILELIST:
#line 496 "Utils.c"
		{
#line 105 "../src/Utils.vala"
			result = _ ("Downloading file lists");
#line 105 "../src/Utils.vala"
			return result;
#line 502 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_DOWNLOAD_CHANGELOG:
#line 506 "Utils.c"
		{
#line 107 "../src/Utils.vala"
			result = _ ("Downloading lists of changes");
#line 107 "../src/Utils.vala"
			return result;
#line 512 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_DOWNLOAD_GROUP:
#line 516 "Utils.c"
		{
#line 109 "../src/Utils.vala"
			result = _ ("Downloading groups");
#line 109 "../src/Utils.vala"
			return result;
#line 522 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_DOWNLOAD_UPDATEINFO:
#line 526 "Utils.c"
		{
#line 111 "../src/Utils.vala"
			result = _ ("Downloading update information");
#line 111 "../src/Utils.vala"
			return result;
#line 532 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_REPACKAGING:
#line 536 "Utils.c"
		{
#line 113 "../src/Utils.vala"
			result = _ ("Repackaging files");
#line 113 "../src/Utils.vala"
			return result;
#line 542 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_LOADING_CACHE:
#line 546 "Utils.c"
		{
#line 115 "../src/Utils.vala"
			result = _ ("Loading cache");
#line 115 "../src/Utils.vala"
			return result;
#line 552 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_SCAN_APPLICATIONS:
#line 556 "Utils.c"
		{
#line 117 "../src/Utils.vala"
			result = _ ("Scanning applications");
#line 117 "../src/Utils.vala"
			return result;
#line 562 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_GENERATE_PACKAGE_LIST:
#line 566 "Utils.c"
		{
#line 119 "../src/Utils.vala"
			result = _ ("Generating package lists");
#line 119 "../src/Utils.vala"
			return result;
#line 572 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_WAITING_FOR_LOCK:
#line 576 "Utils.c"
		{
#line 121 "../src/Utils.vala"
			result = _ ("Waiting for package manager lock");
#line 121 "../src/Utils.vala"
			return result;
#line 582 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_WAITING_FOR_AUTH:
#line 586 "Utils.c"
		{
#line 123 "../src/Utils.vala"
			result = _ ("Waiting for authentication");
#line 123 "../src/Utils.vala"
			return result;
#line 592 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_SCAN_PROCESS_LIST:
#line 596 "Utils.c"
		{
#line 125 "../src/Utils.vala"
			result = _ ("Updating running applications");
#line 125 "../src/Utils.vala"
			return result;
#line 602 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_CHECK_EXECUTABLE_FILES:
#line 606 "Utils.c"
		{
#line 127 "../src/Utils.vala"
			result = _ ("Checking applications in use");
#line 127 "../src/Utils.vala"
			return result;
#line 612 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_CHECK_LIBRARIES:
#line 616 "Utils.c"
		{
#line 129 "../src/Utils.vala"
			result = _ ("Checking libraries in use");
#line 129 "../src/Utils.vala"
			return result;
#line 622 "Utils.c"
		}
#line 61 "../src/Utils.vala"
		case PK_STATUS_ENUM_COPY_FILES:
#line 626 "Utils.c"
		{
#line 131 "../src/Utils.vala"
			result = _ ("Copying files");
#line 131 "../src/Utils.vala"
			return result;
#line 632 "Utils.c"
		}
		default:
		{
#line 133 "../src/Utils.vala"
			result = _ ("Unknown state");
#line 133 "../src/Utils.vala"
			return result;
#line 640 "Utils.c"
		}
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 664 "Utils.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 668 "Utils.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 674 "Utils.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 678 "Utils.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 682 "Utils.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 690 "Utils.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 718 "Utils.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 727 "Utils.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 741 "Utils.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 750 "Utils.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 764 "Utils.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 773 "Utils.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 782 "Utils.c"
}

gchar*
utils_unescape_markup (const gchar* escaped_text)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 138 "../src/Utils.vala"
	g_return_val_if_fail (escaped_text != NULL, NULL);
#line 139 "../src/Utils.vala"
	_tmp0_ = string_replace (escaped_text, "&amp;", "&");
#line 139 "../src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 139 "../src/Utils.vala"
	_tmp2_ = string_replace (_tmp1_, "&lt;", "<");
#line 139 "../src/Utils.vala"
	_tmp3_ = _tmp2_;
#line 139 "../src/Utils.vala"
	_tmp4_ = string_replace (_tmp3_, "&gt;", ">");
#line 139 "../src/Utils.vala"
	_tmp5_ = _tmp4_;
#line 139 "../src/Utils.vala"
	_tmp6_ = string_replace (_tmp5_, "&#39;", "'");
#line 139 "../src/Utils.vala"
	_tmp7_ = _tmp6_;
#line 139 "../src/Utils.vala"
	_g_free0 (_tmp5_);
#line 139 "../src/Utils.vala"
	_g_free0 (_tmp3_);
#line 139 "../src/Utils.vala"
	_g_free0 (_tmp1_);
#line 139 "../src/Utils.vala"
	result = _tmp7_;
#line 139 "../src/Utils.vala"
	return result;
#line 825 "Utils.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 844 "Utils.c"
}

gboolean
utils_is_running_in_demo_mode (void)
{
	GFile* proc_cmdline = NULL;
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 146 "../src/Utils.vala"
	_tmp0_ = g_file_new_for_path ("/proc/cmdline");
#line 146 "../src/Utils.vala"
	proc_cmdline = _tmp0_;
#line 858 "Utils.c"
	{
		GFileInputStream* is = NULL;
		GFile* _tmp1_;
		GFileInputStream* _tmp2_;
		GDataInputStream* dis = NULL;
		GFileInputStream* _tmp3_;
		GDataInputStream* _tmp4_;
		gchar* line = NULL;
		GDataInputStream* _tmp5_;
		gchar* _tmp6_;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		const gchar* _tmp9_;
#line 148 "../src/Utils.vala"
		_tmp1_ = proc_cmdline;
#line 148 "../src/Utils.vala"
		_tmp2_ = g_file_read (_tmp1_, NULL, &_inner_error0_);
#line 148 "../src/Utils.vala"
		is = _tmp2_;
#line 148 "../src/Utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 880 "Utils.c"
			goto __catch0_g_error;
		}
#line 149 "../src/Utils.vala"
		_tmp3_ = is;
#line 149 "../src/Utils.vala"
		_tmp4_ = g_data_input_stream_new ((GInputStream*) _tmp3_);
#line 149 "../src/Utils.vala"
		dis = _tmp4_;
#line 151 "../src/Utils.vala"
		_tmp5_ = dis;
#line 151 "../src/Utils.vala"
		_tmp6_ = g_data_input_stream_read_line (_tmp5_, NULL, NULL, &_inner_error0_);
#line 151 "../src/Utils.vala"
		line = _tmp6_;
#line 151 "../src/Utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 151 "../src/Utils.vala"
			_g_object_unref0 (dis);
#line 151 "../src/Utils.vala"
			_g_object_unref0 (is);
#line 901 "Utils.c"
			goto __catch0_g_error;
		}
#line 152 "../src/Utils.vala"
		_tmp9_ = line;
#line 152 "../src/Utils.vala"
		if (string_contains (_tmp9_, "boot=casper")) {
#line 152 "../src/Utils.vala"
			_tmp8_ = TRUE;
#line 910 "Utils.c"
		} else {
			const gchar* _tmp10_;
#line 152 "../src/Utils.vala"
			_tmp10_ = line;
#line 152 "../src/Utils.vala"
			_tmp8_ = string_contains (_tmp10_, "boot=live");
#line 917 "Utils.c"
		}
#line 152 "../src/Utils.vala"
		if (_tmp8_) {
#line 152 "../src/Utils.vala"
			_tmp7_ = TRUE;
#line 923 "Utils.c"
		} else {
			const gchar* _tmp11_;
#line 152 "../src/Utils.vala"
			_tmp11_ = line;
#line 152 "../src/Utils.vala"
			_tmp7_ = string_contains (_tmp11_, "rd.live.image");
#line 930 "Utils.c"
		}
#line 152 "../src/Utils.vala"
		if (_tmp7_) {
#line 153 "../src/Utils.vala"
			result = TRUE;
#line 153 "../src/Utils.vala"
			_g_free0 (line);
#line 153 "../src/Utils.vala"
			_g_object_unref0 (dis);
#line 153 "../src/Utils.vala"
			_g_object_unref0 (is);
#line 153 "../src/Utils.vala"
			_g_object_unref0 (proc_cmdline);
#line 153 "../src/Utils.vala"
			return result;
#line 946 "Utils.c"
		}
#line 147 "../src/Utils.vala"
		_g_free0 (line);
#line 147 "../src/Utils.vala"
		_g_object_unref0 (dis);
#line 147 "../src/Utils.vala"
		_g_object_unref0 (is);
#line 954 "Utils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 147 "../src/Utils.vala"
		e = _inner_error0_;
#line 147 "../src/Utils.vala"
		_inner_error0_ = NULL;
#line 156 "../src/Utils.vala"
		_tmp12_ = e;
#line 156 "../src/Utils.vala"
		_tmp13_ = _tmp12_->message;
#line 156 "../src/Utils.vala"
		g_critical ("Utils.vala:156: Couldn't detect if running in Demo Mode: %s", _tmp13_);
#line 147 "../src/Utils.vala"
		_g_error_free0 (e);
#line 974 "Utils.c"
	}
	__finally0:
#line 147 "../src/Utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 979 "Utils.c"
		gboolean _tmp14_ = FALSE;
#line 147 "../src/Utils.vala"
		_g_object_unref0 (proc_cmdline);
#line 147 "../src/Utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "../src/Utils.vala"
		g_clear_error (&_inner_error0_);
#line 147 "../src/Utils.vala"
		return _tmp14_;
#line 989 "Utils.c"
	}
#line 159 "../src/Utils.vala"
	result = FALSE;
#line 159 "../src/Utils.vala"
	_g_object_unref0 (proc_cmdline);
#line 159 "../src/Utils.vala"
	return result;
#line 997 "Utils.c"
}

